<!--
  -    Copyright [2020] Feather development team, see AUTHORS.md
  -
  -    Licensed under the Apache License, Version 2.0 (the "License");
  -    you may not use this file except in compliance with the License.
  -    You may obtain a copy of the License at
  -
  -        http://www.apache.org/licenses/LICENSE-2.0
  -
  -    Unless required by applicable law or agreed to in writing, software
  -    distributed under the License is distributed on an "AS IS" BASIS,
  -    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -    See the License for the specific language governing permissions and
  -    limitations under the License.
  -->

<template>
  <v-row>
    <v-col
      v-if="
        applicationStore.session.user.permissions.includes('ADMIN') ||
        applicationStore.session.user.permissions.includes('INVITE')
      "
    >
      <v-card>
        <v-card-title class="red--text">
          Rechteerhöhung für Nichtfördermitglieder verwalten
        </v-card-title>
        <v-card-text>
          <v-alert type="success" v-if="success">
            Anträge wurden wie gewünscht bearbeitet und Rechte ggfs. erfolgreich erteilt.
          </v-alert>

          <v-form ref="form" v-if="!success">
            <v-alert type="warning" v-if="error">
              Bitte folgende Fehler beheben:
              <ul>
                <li v-for="e in error" :key="e">
                  {{ e }}
                </li>
              </ul>
            </v-alert>

            <v-select
              v-model="trialDecision.requestId"
              :items="this.applications"
              item-text="uniqueName"
              item-value="id"
              label="Auswählbare Anträge"
              multiple
              chips
              prepend-icon="mdi-account-group"
              :disabled="loading || sending"
              :loading="loading"
            ></v-select>
          </v-form>
        </v-card-text>
        <v-card-actions>
          <v-btn color="orange darken-2" class="pa-4 white--text" tile @click="reset" v-if="success"
            >Weitere Anträge genehmigen
          </v-btn>
          <v-spacer />
          <v-btn
            color="orange darken-2"
            class="pa-4 white--text"
            tile
            @click="processTrials(true)"
            :loading="sending"
            :disabled="sending || loading || trialDecision.requestId.length == 0"
            v-if="!success"
            >Anträge genehmigen
          </v-btn>
          <v-btn
            color="orange darken-2"
            class="pa-4 white--text"
            tile
            @click="processTrials(false)"
            :loading="sending"
            :disabled="sending || loading || trialDecision.requestId.length == 0"
            v-if="!success"
            >Anträge ablehnen
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-col>
  </v-row>
</template>

<script>
import * as util from '../../util';
import * as api from '../../api';
import { useApplicationStore } from '../../stores/application';

export default {
  mounted() {
    this.reset();
  },
  data: () => {
    return {
      loading: true,
      sending: false,
      success: false,
      error: null,
      users: [],
      items: [],
      applications: [],
      trialDecision: {
        requestId: [],
      },
      applicationStore: useApplicationStore(),
      util,
    };
  },
  methods: {
    reset: function () {
      this.loading = true;
      this.trialDecision.requestId = [];
      this.users = [];
      this.items = [];
      this.applications = [];
      this.error = null;
      this.sending = false;
      this.success = false;

      const getAllTrialRequestsResponse = api.iog
        .getAllTrialRequests()
        .then(
          (it) =>
            (this.applications = it.map((user) =>
              Object.assign(user, { uniqueName: util.userUniqueIdentifier(user) })
            ))
        );
      api.allCatching([getAllTrialRequestsResponse]).finally(() => {
        this.loading = false;
      });
    },
    processTrials: function (accept) {
      this.success = false;

      if (this.$refs.form.validate()) {
        this.sending = true;

        const processTrialRequestsResponse = api.iog
          .processTrialRequests(accept, this.trialDecision.requestId)
          .then(() => {
            this.success = true;
          });
        api.allCatching([processTrialRequestsResponse]).finally(() => (this.sending = false));
      }
    },
  },
};
</script>

<style scoped></style>
